---
title: DataTransferItem.getAsFile()
slug: Web/API/DataTransferItem/getAsFile
tags:
  - API
  - DataTransferItem
  - HTML DOM
  - HTML Drag and Drop API
  - Method
  - Reference
  - drag and drop
---
<div>{{APIRef("HTML Drag and Drop API")}}</div>

<p>If the item is a file, the <strong><code>DataTransferItem.getAsFile()</code></strong> method returns the drag data item's {{domxref("File")}} object. If the item is not a file, this method returns <code>null</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>File</em> = <em>DataTransferItem</em>.getAsFile();
</pre>

<h3 id="Parameters">Parameters</h3>

<p><em>None.</em></p>

<h3 id="Return_value">Return value</h3>

<dl>
 <dt>{{domxref("File")}}</dt>
 <dd>If the drag data item is a file, a {{domxref("File")}} object is returned; otherwise <code>null</code> is returned.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example shows the use of the <code>getAsFile()</code> method in a {{event("drop")}} event handler.</p>

<pre class="brush: js notranslate">function drop_handler(ev) {
 console.log("Drop");
 ev.preventDefault();
 var data = event.dataTransfer.items;
 for (var i = 0; i &lt; data.length; i += 1) {
   if ((data[i].kind == 'string') &amp;&amp;
       (data[i].type.match('^text/plain'))) {
     // This item is the target node
     data[i].getAsString(function (s){
       ev.target.appendChild(document.getElementById(s));
     });
   } else if ((data[i].kind == 'string') &amp;&amp;
              (data[i].type.match('^text/html'))) {
     // Drag data item is HTML
     console.log("... Drop: HTML");
   } else if ((data[i].kind == 'string') &amp;&amp;
              (data[i].type.match('^text/uri-list'))) {
     // Drag data item is URI
     console.log("... Drop: URI");
   } else if ((data[i].kind == 'file') &amp;&amp;
              (data[i].type.match('^image/'))) {
     // Drag data item is an image file
     var f = data[i].getAsFile();
     console.log("... Drop: File ");
   }
 }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'interaction.html#dom-datatransferitem-getasfile','getAsFile()')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial value</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'editing.html#dom-datatransferitem-getasfile','getAsFile()')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>Snapshot of the HTML WHATWG document</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransferItem.getAsFile")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("DataTransfer.files")}}</li>
</ul>
